var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useState } from 'react';
import ReactDOM from 'react-dom';
import './styles.css'; // Import the CSS file
var Highlight = function (_a) {
    var value = _a.value;
    return (_jsx("span", __assign({ className: "highlight-text" }, { children: value })));
};
var HighlightText = function (_a) {
    var text = _a.text, value = _a.value, _b = _a.caseIgnored, caseIgnored = _b === void 0 ? true : _b;
    if (!value)
        return _jsx(_Fragment, { children: text });
    var splitMatch = new RegExp(value.replace(/\\/g, '\\\\'), caseIgnored ? 'ig' : 'g');
    var values = text.match(splitMatch) || [];
    var matched = text.split(splitMatch);
    return (_jsx("div", { children: matched.map(function (item, idx) { return (_jsxs(React.Fragment, { children: [item, idx < values.length && _jsx(Highlight, { value: values[idx] })] }, idx)); }) }));
};
var Dropdown = function (_a) {
    var options = _a.options, _b = _a.multiSelect, multiSelect = _b === void 0 ? false : _b, customRenderOption = _a.customRenderOption, _c = _a.searchable, searchable = _c === void 0 ? true : _c, _d = _a.usePortal, usePortal = _d === void 0 ? false : _d, _e = _a.zIndex, zIndex = _e === void 0 ? 1000 : _e, onSelect = _a.onSelect;
    var _f = useState(false), isOpen = _f[0], setIsOpen = _f[1];
    var _g = useState(''), searchTerm = _g[0], setSearchTerm = _g[1];
    var _h = useState([]), selectedOptions = _h[0], setSelectedOptions = _h[1];
    var filteredOptions = options.filter(function (option) {
        return option.label.toLowerCase().includes(searchTerm.toLowerCase());
    });
    var handleOptionClick = function (option) {
        if (multiSelect) {
            var newSelection = selectedOptions.includes(option)
                ? selectedOptions.filter(function (o) { return o !== option; })
                : __spreadArray(__spreadArray([], selectedOptions, true), [option], false);
            setSelectedOptions(newSelection);
            onSelect(newSelection);
        }
        else {
            setSelectedOptions([option]);
            onSelect(option);
            setIsOpen(false);
        }
    };
    var handleRemoveOption = function (option) {
        var newSelection = selectedOptions.filter(function (o) { return o !== option; });
        setSelectedOptions(newSelection);
        onSelect(newSelection);
    };
    var handleClearSearch = function () {
        setSearchTerm('');
    };
    var handleDropdownClick = function () {
        setIsOpen(!isOpen);
    };
    var handleDocumentClick = function (event) {
        var target = event.target;
        var dropdownElement = document.querySelector('.dropdown-container');
        if (dropdownElement && !dropdownElement.contains(target)) {
            setIsOpen(false);
        }
    };
    // Add document click event listener when dropdown is open
    if (isOpen) {
        document.addEventListener('mousedown', handleDocumentClick);
    }
    else {
        document.removeEventListener('mousedown', handleDocumentClick);
    }
    var renderOption = function (option) { return (_jsxs("div", __assign({ onClick: function () { return handleOptionClick(option); }, className: "dropdown-option ".concat(selectedOptions.includes(option) ? 'selected' : '') }, { children: [option.icon && _jsx("div", __assign({ className: "option-icon" }, { children: option.icon })), _jsx("div", __assign({ className: "keyword-wrapper" }, { children: _jsx(HighlightText, { text: option.label, value: searchTerm }) }))] }), option.value)); };
    var dropdownContent = (_jsxs("div", __assign({ className: "dropdown-content", style: { zIndex: zIndex } }, { children: [searchable && (_jsxs("div", __assign({ className: "search-bar" }, { children: [_jsx("span", { className: "search-icon" }), _jsx("input", { type: "text", value: searchTerm, onChange: function (e) { return setSearchTerm(e.target.value); }, placeholder: "", className: "search-input" }), searchTerm && _jsx("button", __assign({ onClick: handleClearSearch, className: "clear-button" }, { children: _jsx("span", { className: "clear-icon" }) }))] }))), filteredOptions.length ? (filteredOptions.map(function (option) { return renderOption(option); })) : (_jsx("div", __assign({ className: "no-options" }, { children: "No options found" })))] })));
    return (_jsxs("div", __assign({ className: "dropdown-container" }, { children: [_jsxs("div", __assign({ onClick: handleDropdownClick, className: "dropdown-trigger" }, { children: [_jsx("div", __assign({ className: "dropdown-selected-options" }, { children: selectedOptions.length
                            ? selectedOptions.map(function (option) { return (_jsx(SelectedOption, { option: option, onRemove: handleRemoveOption }, option.value)); })
                            : 'Select' })), _jsx("span", { className: "dropdown-icon" })] })), isOpen &&
                (usePortal
                    ? ReactDOM.createPortal(dropdownContent, document.body)
                    : dropdownContent)] })));
};
var SelectedOption = function (_a) {
    var option = _a.option, onRemove = _a.onRemove;
    return (_jsxs("span", __assign({ className: "selected-option" }, { children: [option.label, _jsx("button", __assign({ onClick: function () { return onRemove(option); }, className: "close-button" }, { children: _jsx("span", { className: "close-icon" }) }))] })));
};
export default Dropdown;
